-- Teorie k cizím klíčům relací

DROP TABLE IF EXISTS movie CASCADE;

CREATE TABLE movie (
    title text,
    year integer,
    PRIMARY KEY ( title, year )
); 
-- Film "title"  byl vytvořený roku "year".

INSERT INTO movie VALUES 
     ( 'The Matrix', 1999), 
     ( 'Dracula', 1992 );

TABLE movie;

DROP TABLE IF EXISTS movie_cast;

CREATE TABLE movie_cast (
  actor_name text,
  movie_title text,
  movie_year integer,
  PRIMARY KEY ( actor_name, movie_title, movie_year )
);
-- Herec "actor_name" hrál ve filmu "movie_title" z roku "movie_year".

INSERT INTO movie_cast VALUES 
     ( 'Keano Reeves', 'The Matrix', 1999 ), 
     ( 'Keano Reeves', 'Dracula', 1992 ),
     ( 'Laurence Fishburne', 'The Matrix', 1999 ),
     ( 'Gary Oldman', 'Dracula', 1992);

TABLE movie_cast;
/*
( movie_title, movie_year ) je cizím klíčem
základní relace casting na ( title, year ) základní relace movies,
právě když je { title, year } nadklíčem movies
a následující relace je prázdná.
*/
( SELECT DISTINCT  
         movie_title AS title,
         movie_year AS year
  FROM   movie_cast )
  EXCEPT
( SELECT DISTINCT 
         title,
         year
  FROM   movie );

-- Porušíme:
INSERT INTO casting VALUES
     ( 'Gary Oldman', 'Batman Begins', 2005);
